'use strict';

class CollapsiblePanel extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            open: !!props.open
        };
    }

    onClick() {
        this.setState({
            open: !this.state.open
        });
    }

    render() {
        const e = React.createElement;

        var classNames = ["CollapsiblePanel"];
        if (this.props.className) classNames.push(this.props.className);
        classNames = classNames.join(" ");

        return e("div", {className: classNames}, [
            e("div", {
                key: "header",
                className: "CollapsiblePanel__Header",
                onClick: () => this.onClick(),
            }, e("div", {}, this.props.children[0] || "none")),
            e("div", {
                key: "content",
                className: "CollapsiblePanel__Body",
                style: {
                    height: this.state.open ? "auto": 0
                }
            }, e('div', {}, this.props.children.slice(1) || "none"))
        ])
    }
}; // CollapsiblePanel
