let UserInterfaceHelpers = (document) => {
    const class_uniquepanel = "ui-uniquepanel";

    let docAll = document.querySelectorAll.bind(document);
        status_template = docAll("template#panel-robot")[0];

    const unique_panel = (classid, container) => {
        var el = container.querySelector("." + classid);
        if (!el){
            el = document.createElement("div");
            el.classList.add(classid, class_uniquepanel);
            el.appendChild(status_template.content.cloneNode(true));
            container.append(el);
        }
        return el;
    }

    return {
        unique_panel: unique_panel,
        reset: () => {
            docAll("." + class_uniquepanel).forEach(e => e.remove());
        }
    }
}

async function update_user_interface(serverState, robotById) {
    let status_container = document.querySelector("#status-robots");
    Object.values(robotById).forEach(robot => {
        var el = uiHelpers.unique_panel(
            "robot-" + robot.id + "-status",
            status_container);

        el.innerText = "[" + robot.id + "] health: " + robot.health
    });

    /*
    var lines = [];
    Object
        .values(robotById)
        .sort((a, b) => (a.health > b.health ? -1 : 1))
        .forEach(robot => {
            if (!robot.active) return;
            lines.push("[" + robot.id + "] health: " + robot.health + "\n");
            lines.push("heading: " + robot.text.robotHeading + "\n");
            lines.push("accuracy: " + robot.text.projectileAccuracy + "\n");
            lines.push("scanner: " + robot.text.scannerSummary + "\n");
            lines.push("edge proximity: " + robot.text.proximityEdge + "\n");
            lines.push("closest robot: " + robot.text.scannerClosestRobot + "\n");
            lines.push("\n");
        });
    document.querySelector("#info-active").innerHTML = lines.join("");

    var lines = [];
    Object
        .values(robotById)
        .sort((a, b) => (a.health > b.health ? -1 : 1))
        .forEach(robot => {
            if (robot.active) return;
            lines.push("[" + robot.id + "] health: " + robot.health + "\n");
            lines.push("heading: " + robot.text.robotHeading + "\n");
            lines.push("accuracy: " + robot.text.projectileAccuracy + "\n");
            lines.push("scanner: " + robot.text.scannerSummary + "\n");
            lines.push("edge proximity: " + robot.text.proximityEdge + "\n");
            lines.push("closest robot: " + robot.text.scannerClosestRobot + "\n");
            lines.push("\n");
        });
    document.querySelector("#info-dead").innerHTML = lines.join("");
    */

    document.querySelector("#frame").textContent = serverState.frame;
    document.querySelector("#active").textContent = serverState.active;
    document.querySelector("#inits").textContent = serverState.inits;
    document.querySelector("#seconds").textContent = Math.round(serverState.seconds * 100) / 100;
    document.querySelector("#projectiles").textContent = serverState.projectiles;

    var lines = [];
    var animstates = Animator.Factory.get_saved_states();
    Object.keys(animstates).forEach(k => {
        lines.push(k + " :: " + JSON.stringify(animstates[k]));
    });
    document.querySelector("#animstates").textContent = lines.join("\n");
}
